// edit these #defines before you build

#define SCREEN_WIDTH 1280
#define SCREEN_HEIGHT 1024

// adjust the speed if you like
#define ZOOM_SPEED 0.03f
#define PAN_SPEED 2.0f

// if the mouse seems backwards to you, swap the values on these two:
#define ZOOMING_IN -1
#define ZOOMING_OUT 1


// OK, that's it for the settings. the rest is my crappy code, much of which
// has been shamelessly stolen from various examples and tutorials
// 
// many thanks to the SDL manual, nehe.gamedev.net tutorials, and #opengl on
// irc.freenode.net


#include <SDL/SDL.h>
#include <GL/gl.h>
#include <GL/glu.h>

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>



float edit_x = -0.559017, edit_y = 0.303692, edit_zoom = 1.402591;
//static float zoom = 0.1f;
//float x = -0.7475f * zoom;
//float y = 0.865f * zoom ;

int screen_center_x;
int screen_center_y;

int mouse_dx = 0;
int mouse_dy = 0;
int mouse_x;
int mouse_y;

#define ZOOMING_NONE 0
int zooming = ZOOMING_NONE;


// gluttest/1.c

GLuint texture[1];

void* read_whole_file(const char* filename, int size) {
	char* buf;
	int fd;

	buf = malloc(size);
	if(buf == 0) {
		exit(2);
	}

	fd = open(filename, O_RDONLY);

	if(fd == -1) {
		exit(3);
	}

	if(read(fd, buf, size) != size) {
		exit(4);
	}

	close(fd);

	return buf;
}


void draw_text(const char* text, int count, float x, float y, float width, int color)
{
	float zoom = width / count;
	int c;
	float tex_x, tex_y;
	//static int textures_enabled = 1;

	if(zoom < .002) return;

#define CHAR_WIDTH (1.0f/25.6f)
#define CHAR_HEIGHT (2.0f/25.6f)
			


	//if(zoom < .008) {
		//if(textures_enabled) {
			//glDisable(GL_TEXTURE_2D);
			//textures_enabled = 0;
		//}
		//glColor3f((float)(color & 4) / 12.0f, (float)(color & 2) / 6.0f, (float)(color & 1) / 3.0f);
		//glRectf(x, y, x + width, y + zoom * 2);
	//}
	//else
	{
		//if(!textures_enabled) {
			//glEnable(GL_TEXTURE_2D);
			//textures_enabled = 1;
		//}
		glColor3f((float)(color & 4), (float)(color & 2), (float)(color & 1));
		glBindTexture(GL_TEXTURE_2D, texture[0]); // choose which texture we're using
		glBegin(GL_QUADS);

		for(c = 0; c < count; ++c) {
			tex_x = text[c] % 16;
			tex_x /= 25.6f;

			tex_y = (int)(text[c] / 16);
			tex_y /= 12.8f;

			// Bottom Left Of The Texture and Quad:
			glTexCoord2f(tex_x, tex_y + CHAR_HEIGHT); glVertex2f(x, y);
			// Bottom Right Of The Texture and Quad:
			glTexCoord2f(tex_x + CHAR_WIDTH, tex_y + CHAR_HEIGHT); glVertex2f(x + zoom, y);
			// Top Right Of The Texture and Quad:
			glTexCoord2f(tex_x + CHAR_WIDTH, tex_y); glVertex2f(x + zoom, y + zoom * 2);
			// Top Left Of The Texture and Quad:
			glTexCoord2f(tex_x, tex_y); glVertex2f(x, y + zoom * 2);
			x += zoom;
		}
		glEnd();
	}
}


void setup_texture() {
	//char* edit_texture = read_whole_file("glupe.pnm", 12288);
	char* edit_texture = read_whole_file("termfont.dat", 196608);

	// tell gl we're using textures

	// Create The Texture
	glGenTextures(1, &texture[0]); // create a new texture id

	glBindTexture(GL_TEXTURE_2D, texture[0]); // select this texture

	// load pixels into texture
	glTexImage2D(GL_TEXTURE_2D, 0, 3, 256, 256, 0, GL_RGB, GL_UNSIGNED_BYTE, edit_texture);

	// I could use GL_NEAREST or GL_LINEAR if this is slow to scale
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR); // Linear Filtering                            
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR); // Linear Filtering                            

	free(edit_texture);
}

void cleanup_texture() {
	glDeleteTextures(1, &texture[0]);
}


void quit() {
	cleanup_texture();
	SDL_Quit( );
	exit(0);
}

void handle_key_up(SDLKey key) {
	zooming = ZOOMING_NONE;
}

void handle_key_down(SDLKey key) {
	switch(key) {
		case SDLK_q:
		case SDLK_ESCAPE:
			quit();
			break;
		case SDLK_SPACE:
			break;
		case SDLK_u:
			zooming = ZOOMING_OUT;
			break;
		case SDLK_e:
			zooming = ZOOMING_IN;
			break;
		default:
			break;
	}
}

void handle_mouse_down(int button) {
	switch(button) {
		case SDL_BUTTON_RIGHT:
			zooming = ZOOMING_IN;
			break;
		case SDL_BUTTON_LEFT:
		case SDL_BUTTON_MIDDLE:
			zooming = ZOOMING_OUT;
	}
}

void handle_mouse_up(int button) {
	zooming = ZOOMING_NONE;
}

void handle_mouse_move(int x, int y) {
	// ignore the mouse moving back to the origin (it's 99.9% because we warped it back)
	if(!(x == screen_center_x && y == screen_center_y)) {
		mouse_dx += x - mouse_x;
		mouse_dy += y - mouse_y;
	}

	mouse_x = x;
	mouse_y = y;
}

static void process_events( void ) {
	SDL_Event event;

	while(SDL_PollEvent(&event)) {

		switch(event.type) {
			case SDL_KEYDOWN:
				handle_key_down(event.key.keysym.sym);
				break;
			case SDL_KEYUP:
				handle_key_up(event.key.keysym.sym);
				break;
			case SDL_MOUSEBUTTONDOWN:
				handle_mouse_down(event.button.button);
				break;
			case SDL_MOUSEBUTTONUP:
				handle_mouse_up(event.button.button);
				break;
			case SDL_MOUSEMOTION:
				handle_mouse_move(event.motion.x, event.motion.y);
				break;
			case SDL_QUIT:
				quit();
				break;
		}
	}
}

static void draw_screen(float x, float y, float zoom) {
    glClear(GL_COLOR_BUFFER_BIT);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

#define COLOR_RED 4
#define COLOR_GREEN 2
#define COLOR_BLUE 1
#define COLOR_WHITE 7

// yeah, I know this is cheezy. sorry
#include "enc.c"


    SDL_GL_SwapBuffers( );
    
    return;
}

static void setup_opengl( int width, int height )
{
	glEnable(GL_TEXTURE_2D);

	// FIXME what should the fourth value be here?
	glClearColor(0, 0, 0, 0.5f );

	glViewport( 0, 0, width, height );
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	//     (left, right, bottom, top, near,   far)
	glOrtho(-1.1f, 1.1f, -1.1f, 1.1f, 200.0f, -200.0f);

	setup_texture();
}

int main( int argc, char* argv[] )
{
	/* Information about the current video settings. */
	const SDL_VideoInfo* info = NULL;
	/* Dimensions of our window. */
	int width = 0;
	int height = 0;
	/* Color depth in bits of our window. */
	int bpp = 0;
	/* Flags we will pass into SDL_SetVideoMode. */
	int flags = 0;
	int i;

	/* First, initialize SDL's video subsystem. */
	if( SDL_Init( SDL_INIT_VIDEO ) < 0 ) {
	/* Failed, exit. */
	fprintf( stderr, "Video initialization failed: %s\n",
	     SDL_GetError( ) );
	quit();
	}

	/* Let's get some video information. */
	info = SDL_GetVideoInfo( );

	if( !info ) {
	/* This should probably never happen. */
	fprintf( stderr, "Video query failed: %s\n",
	     SDL_GetError( ) );
	quit();
	}

	width = SCREEN_WIDTH;
	height = SCREEN_HEIGHT;
	mouse_x = screen_center_x = SCREEN_WIDTH / 2;
	mouse_y = screen_center_y = SCREEN_HEIGHT / 2;
	bpp = info->vfmt->BitsPerPixel;

    SDL_GL_SetAttribute( SDL_GL_RED_SIZE, 5 );
    SDL_GL_SetAttribute( SDL_GL_GREEN_SIZE, 5 );
    SDL_GL_SetAttribute( SDL_GL_BLUE_SIZE, 5 );
    //SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 16 );
    SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );

    /*
     * We want to request that SDL provide us
     * with an OpenGL window, in a fullscreen
     * video mode.
     *
     * EXERCISE:
     * Make starting windowed an option, and
     * handle the resize events properly with
     * glViewport.
     */
    flags = SDL_OPENGL | SDL_FULLSCREEN;

    /*
     * Set the video mode
     */
    if( SDL_SetVideoMode( width, height, bpp, flags ) == 0 ) {
        /*
         * This could happen for a variety of reasons,
         * including DISPLAY not being set, the specified
         * resolution not being available, etc.
         */
        fprintf( stderr, "Video mode set failed: %s\n",
             SDL_GetError( ) );
        quit();
    }

    /*
     * At this point, we should have a properly setup
     * double-buffered window for use with OpenGL.
     */
    setup_opengl( width, height );

	// hide the cursor
	SDL_ShowCursor(SDL_DISABLE);


	i = 400;
	//while(i--) { // use this to calculate framerate
	while(i) {
		// handle events
		process_events( );

		// pan
		if(mouse_dx || mouse_dy) {
			edit_x -= PAN_SPEED * (((float)mouse_dx) / edit_zoom) / width;
			edit_y += PAN_SPEED * (((float)mouse_dy) / edit_zoom) / height;
			mouse_dx = mouse_dy = 0;

			SDL_WarpMouse(screen_center_x, screen_center_y);
		}

		// zoom
		if(zooming) {
			// FIXME: use SDL_GetTicks() to zoom propper amount
			edit_zoom += ZOOM_SPEED * edit_zoom * zooming;
		}

		// redraw
		draw_screen(edit_x * edit_zoom, edit_y * edit_zoom, edit_zoom);
	}

	quit();
	return 0;
}
